/*----- PROTECTED REGION ID(KeithleyElectrometers.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        KeithleyElectrometers.cpp
//
// description : C++ source for the KeithleyElectrometers class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               KeithleyElectrometers are implemented in this file.
//
// project :     Keithley Electrometer
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


// #include <tango.h>
// #include <KeithleyElectrometers.h>
#include "KeithleyElectrometersClass.h"
#include <Keithley_485.h>
#include <Keithley_486.h>
#include <Keithley_487.h>
#include <Keithley_617.h>
#include <Keithley_6485.h>
#include <Keithley_6487.h>
#include <Keithley_6512.h>
#include <Keithley_6514.h>
#include <Keithley_6517.h>
#include <PogoHelper.h>
#include <yat/utils/XString.h>
#include <yat/Portability.h>    //- NaN
#include <yat/utils/String.h>   //- use Format
#include <yat/utils/Logging.h>   //- use fcout

/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers.cpp

/**
 *  KeithleyElectrometers class description:
 *    This class allows you to control all Keithley electrometers
 *    ( with either DDC or SCPI commands ) through a GPIB.
 *    <br> Supported types :
 *    <br> Keithley Electrometers : DDC types -> 485, 486, 487, 617, 6512
 *    <br> Keithley Electrometers : SCPI types -> 6485, 6487, 6514, 6517
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name          |  Method name
//================================================================
//  State                 |  dev_state
//  Status                |  dev_status
//  RangeUP               |  range_up
//  RangeDOWN             |  range_down
//  AutoRangeON           |  auto_range_on
//  AutoRangeOFF          |  auto_range_off
//  ZeroCheckON           |  zero_check_on
//  ZeroCheckOFF          |  zero_check_off
//  ZeroCorrectON         |  zero_correct_on
//  ZeroCorrectOFF        |  zero_correct_off
//  AutoZeroON            |  auto_zero_on
//  AutoZeroOFF           |  auto_zero_off
//  SetAmperMeterMode     |  set_amper_meter_mode
//  SetVoltMeterMode      |  set_volt_meter_mode
//  SetOhmMeterMode       |  set_ohm_meter_mode
//  SetCoulombMeterMode   |  set_coulomb_meter_mode
//  ClearRegisters        |  clear_registers
//  AverageStateON        |  average_state_on
//  AverageStateOFF       |  average_state_off
//  ClearBuffer           |  clear_buffer
//  Start                 |  start
//  Reset                 |  reset
//  Abort                 |  abort
//  EnableSRQBufferFull   |  enable_srqbuffer_full
//  DisableSRQBufferFull  |  disable_srqbuffer_full
//  GetKeithleyConfig     |  get_keithley_config
//  GetRange              |  get_range
//  SetRange              |  set_range
//  GetMode               |  get_mode
//  GetIntegrationTime    |  get_integration_time
//  SetIntegrationTime    |  set_integration_time
//  VSourceOutputON       |  vsource_output_on
//  VSourceOutputOFF      |  vsource_output_off
//  SaveConfiguration     |  save_configuration
//  RestoreConfiguration  |  restore_configuration
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  value          |  Tango::DevDouble	Scalar
//  range          |  Tango::DevDouble	Scalar
//  mode           |  Tango::DevString	Scalar
//  isAutoRangeOn  |  Tango::DevBoolean	Scalar
//  rangesList     |  Tango::DevString	Spectrum  ( max = 64)
//================================================================

namespace KeithleyElectrometers_ns
{
/*----- PROTECTED REGION ID(KeithleyElectrometers::namespace_starting) ENABLED START -----*/

//	static initializations
const int MAX_LENGTH  = 64;

/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometers::KeithleyElectrometers()
 *	Description : Constructors for a Tango device
 *                implementing the classKeithleyElectrometers
 */
//--------------------------------------------------------
KeithleyElectrometers::KeithleyElectrometers(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(KeithleyElectrometers::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::constructor_1
}
//--------------------------------------------------------
KeithleyElectrometers::KeithleyElectrometers(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(KeithleyElectrometers::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::constructor_2
}
//--------------------------------------------------------
KeithleyElectrometers::KeithleyElectrometers(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(KeithleyElectrometers::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometers::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void KeithleyElectrometers::delete_device()
{
	DEBUG_STREAM << "KeithleyElectrometers::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	//  Delete device's allocated object
  DELETE_SCALAR_ATTRIBUTE (attr_value_read);
  DELETE_SCALAR_ATTRIBUTE (attr_range_read);
  DELETE_DEVSTRING_ATTRIBUTE(attr_mode_read);
  DELETE_SCALAR_ATTRIBUTE (attr_isAutoRangeOn_read);
  DELETE_SPECTRUM_ATTRIBUTE(attr_rangesList_read);
  
  remove_dynamic_attibutes();

  if(this->_electrometer)
  {
    delete _electrometer;
    _electrometer = 0;
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::delete_device
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometers::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void KeithleyElectrometers::init_device()
{
	DEBUG_STREAM << "KeithleyElectrometers::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	this->_electrometer = 0;
  this->_statusStr.clear();
  this->_kSCPItype  = false;
  this->_init_failed= true;
  this->_integrationStarted = false;
  this->_is_srqbuffer_full_enabled = false;
  this->_added_attributes.clear();
  this->_added_attribute_name.clear();
  //--------------------------------------------
  CREATE_SCALAR_ATTRIBUTE (attr_value_read);
  CREATE_SCALAR_ATTRIBUTE (attr_range_read);
  CREATE_DEVSTRING_ATTRIBUTE(attr_mode_read,MAX_LENGTH,"UNKNOWN");
  CREATE_SCALAR_ATTRIBUTE (attr_isAutoRangeOn_read);
  CREATE_SPECTRUM_ATTRIBUTE(attr_rangesList_read,MAX_LENGTH);

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::init_device_before

	//	Get the device properties from database
	get_device_property();
	
	/*----- PROTECTED REGION ID(KeithleyElectrometers::init_device) ENABLED START -----*/
	
	//	Initialize device

  try
  {
    //- Keithley model obj instanciation
    create_keithleyModel_object();

    //- if channel multiplexer is used
    create_dynamic_attributes();

    this->_init_failed = false;
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    if(this->_electrometer)
    {
      delete this->_electrometer;
      this->_electrometer = 0;
    }
    Tango::DevFailed df = electrometer_to_tango_exception(ke);
    FATAL_STREAM << "Init device caught a ElectrometerException exception :\n" << df << std::endl;
  }
  catch(Tango::DevFailed & df)
  {
    if(this->_electrometer)
    {
      delete this->_electrometer;
      this->_electrometer = 0;
    }
    FATAL_STREAM << "Init device caught Tango::DevFailed exception :\n" << df << std::endl;
  }
  catch(...)
  {
    if(this->_electrometer)
    {
      delete this->_electrometer;
      this->_electrometer = 0;
    }
    FATAL_STREAM << "Init device caught a UNKNOWN exception !" << std::endl;
  }

  if( !this->_init_failed )
  {
    set_state(Tango::ON);
    set_status("Device ready.");
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::init_device
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometers::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void KeithleyElectrometers::get_device_property()
{
	/*----- PROTECTED REGION ID(KeithleyElectrometers::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	communicationLinkName = "noCommunication/Proxy/Defined";
  electrometerType      = 0;
  useMultiplexedChannels= false;
  createDynamicVSourceAttribute = false;

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("CommunicationLinkName"));
	dev_prop.push_back(Tango::DbDatum("ElectrometerType"));
	dev_prop.push_back(Tango::DbDatum("UseMultiplexedChannels"));
	dev_prop.push_back(Tango::DbDatum("CreateDynamicVSourceAttribute"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on KeithleyElectrometersClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		KeithleyElectrometersClass	*ds_class =
			(static_cast<KeithleyElectrometersClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize CommunicationLinkName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  communicationLinkName;
		else {
			//	Try to initialize CommunicationLinkName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  communicationLinkName;
		}
		//	And try to extract CommunicationLinkName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  communicationLinkName;

		//	Try to initialize ElectrometerType from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  electrometerType;
		else {
			//	Try to initialize ElectrometerType from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  electrometerType;
		}
		//	And try to extract ElectrometerType value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  electrometerType;

		//	Try to initialize UseMultiplexedChannels from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  useMultiplexedChannels;
		else {
			//	Try to initialize UseMultiplexedChannels from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  useMultiplexedChannels;
		}
		//	And try to extract UseMultiplexedChannels value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  useMultiplexedChannels;

		//	Try to initialize CreateDynamicVSourceAttribute from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  createDynamicVSourceAttribute;
		else {
			//	Try to initialize CreateDynamicVSourceAttribute from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  createDynamicVSourceAttribute;
		}
		//	And try to extract CreateDynamicVSourceAttribute value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  createDynamicVSourceAttribute;

	}

	/*----- PROTECTED REGION ID(KeithleyElectrometers::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	//- Creates default property
  Tango::DbData data_put;
  if ( dev_prop[0].is_empty() )
  {
    Tango::DbDatum  prop("CommunicationLinkName");
    prop  <<  communicationLinkName;
    data_put.push_back(prop);
  }
  if ( dev_prop[1].is_empty() )
  {
    Tango::DbDatum  prop("ElectrometerType");
    prop  <<  electrometerType;
    data_put.push_back(prop);
  }

  //- write default property if created
  if( !data_put.empty() )
  {
    get_db_device()->put_property(data_put);
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::get_device_property_after
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometers::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void KeithleyElectrometers::always_executed_hook()
{
	// DEBUG_STREAM << "KeithleyElectrometers::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometers::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void KeithleyElectrometers::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	// DEBUG_STREAM << "KeithleyElectrometers::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code

  if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::read_attr_hardware()"
    );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometers::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void KeithleyElectrometers::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	// DEBUG_STREAM << "KeithleyElectrometers::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
  if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::write_attr_hardware()"
    );
  }
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute value related method
 *	Description: Switch the selected mode it represents the value(s) returned in\n- amp if the AmpereMeter function is selected\n- volt in Volt Meter mode\n- ohm in Ohm Meter mode\n- coulomb in Coulomb Meter mode
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyElectrometers::read_value(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyElectrometers::read_value(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::read_value) ENABLED START -----*/
	std::string dataStr;

  try
  {
    if(this->_electrometer)
    {
      //- get the electrometer data (value) : TODO -> lib Elec has to return a double type value
      dataStr = this->_electrometer->get_value();
      if ( !dataStr.empty() )
      {
        dataStr =  dataStr.substr(0, dataStr.length()-1);
        *attr_value_read  = yat::XString<double>::to_num(dataStr);
      }
      else
      {
        attr.set_quality(Tango::ATTR_INVALID);
      }
    }
    else
    {
      *attr_value_read = yat::IEEE_NAN;
      attr.set_quality(Tango::ATTR_ALARM);
    }
    attr.set_value(attr_value_read);
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    attr.set_quality(Tango::ATTR_INVALID);
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      "UNKNOWN_ERROR",
                                      "Failed to read the value [caught electrometer exception].",
                                      "KeithleyElectrometer::read_value()",
                                      Tango::ERR
                                     );
  }
  catch(Tango::DevFailed & df)
  {
    attr.set_quality(Tango::ATTR_INVALID);
    Tango::Except::re_throw_exception(df,
                                      "UNKNOWN_ERROR",
                                      "Failed to read the value [caught DevFailed exception].",
                                      "KeithleyElectrometer::read_value()"
                                     );
  }
  catch(...)
  {
    attr.set_quality(Tango::ATTR_INVALID);
    Tango::Except::throw_exception(
      "UNKNOWN_ERROR",
      "Failed to read the value [caught UNKNOWN exception].",
      "KeithleyElectrometer::read_value()"
    );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::read_value
}
//--------------------------------------------------------
/**
 *	Read attribute range related method
 *	Description: Range of the selected mode
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyElectrometers::read_range(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyElectrometers::read_range(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::read_range) ENABLED START -----*/
    std::string range = _electrometer->get_ElectroMeterRange();
    
   *attr_range_read  = yat::XString<double>::to_num(range);

   //	Set the attribute value
  attr.set_value(attr_range_read);
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::read_range
}
//--------------------------------------------------------
/**
 *	Write attribute range related method
 *	Description: Range of the selected mode
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyElectrometers::write_range(Tango::WAttribute &attr)
{
	// DEBUG_STREAM << "KeithleyElectrometers::write_range(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(KeithleyElectrometers::write_range) ENABLED START -----*/

  //- convert to string
  std::string range_str = yat::Format("{}") % w_val;
    
  _electrometer->set_ElectroMeterRange(range_str);
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::write_range
}
//--------------------------------------------------------
/**
 *	Read attribute mode related method
 *	Description: The selected mode
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyElectrometers::read_mode(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyElectrometers::read_mode(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::read_mode) ENABLED START -----*/
  *attr_mode_read = CORBA::string_dup( _electrometer->get_ElectroMeterMode().c_str() );
	//	Set the attribute value
	attr.set_value(attr_mode_read);
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::read_mode
}
//--------------------------------------------------------
/**
 *	Read attribute isAutoRangeOn related method
 *	Description: True if auto range ON.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyElectrometers::read_isAutoRangeOn(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyElectrometers::read_isAutoRangeOn(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::read_isAutoRangeOn) ENABLED START -----*/
  *attr_isAutoRangeOn_read = false;

  std::string resp = _electrometer->is_autoRange_on();
  if(resp.find("1") != std::string::npos)
  {
    *attr_isAutoRangeOn_read = true;
  }
	//	Set the attribute value
	attr.set_value(attr_isAutoRangeOn_read);
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::read_isAutoRangeOn
}
//--------------------------------------------------------
/**
 *	Read attribute rangesList related method
 *	Description: Ranges list of the selected mode
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 64
 */
//--------------------------------------------------------
void KeithleyElectrometers::read_rangesList(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyElectrometers::read_rangesList(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::read_rangesList) ENABLED START -----*/
    std::vector<std::string> r_list = _electrometer->ranges_list();
    std::size_t nb_elements = r_list.size();
    
    for (std::size_t i=0; i < nb_elements; i++)
    {
      attr_rangesList_read[i] = CORBA::string_dup(r_list[i].c_str());
    }
	//	Set the attribute value
	attr.set_value(attr_rangesList_read, nb_elements);
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::read_rangesList
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometers::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void KeithleyElectrometers::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(KeithleyElectrometers::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command State related method
 *	Description: This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *
 *	@returns State Code
 */
//--------------------------------------------------------
Tango::DevState KeithleyElectrometers::dev_state()
{
	// DEBUG_STREAM << "KeithleyElectrometers::State()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::dev_state) ENABLED START -----*/
	
	Tango::DevState	argout = Tango::UNKNOWN; // replace by your own algorithm
	//	Add your own code
//   DEBUG_STREAM << "KeithleyElectrometers::dev_state(): entering... !" << endl;

  bool SRQState = false;
  int tmpState = -1;

  if(this->_init_failed || !this->_electrometer)
  {
    argout = Tango::FAULT;
    set_status("Keithley device initialisation failed.");
    set_state(argout);
    return argout;
  }
  //  Add your own code to control device here
  try
  {
    //- get device state
    tmpState = this->_electrometer->electrometer_state();

    if(tmpState == Tango::FAULT)
      argout =  Tango::FAULT;
    else if(tmpState == Tango::ALARM)
      argout =  Tango::ALARM;
    else
      argout = Tango::ON;

    //- update state
    set_state(argout);
  }
  catch(...)
  {
    set_state(Tango::ALARM);
    throw;
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::dev_state
	set_state(argout);    // Give the state to Tango.
	if (argout!=Tango::ALARM)
		Tango::DeviceImpl::dev_state();
	return get_state();  // Return it after Tango management.
}
//--------------------------------------------------------
/**
 *	Command Status related method
 *	Description: This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
 *
 *	@returns Status description
 */
//--------------------------------------------------------
Tango::ConstDevString KeithleyElectrometers::dev_status()
{
	// DEBUG_STREAM << "KeithleyElectrometers::Status()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::dev_status) ENABLED START -----*/
	
	string	status = "Device is OK";
	//	Add your own code
	try
  {
    if(this->_init_failed || !this->_electrometer)
      _statusStr = "Keithley device initialisation failed.";
    else
      _statusStr = this->_electrometer->electrometer_status();

    INFO_STREAM << "KeithleyElectrometers::dev_status() :\n" << _statusStr << std::endl;
  }
  catch(const electrometer::ElectrometerException& ke)
  {

    ERROR_STREAM << "Cannot perform electrometer_status() command" << std::endl;
    set_state(Tango::ALARM);
    set_status("Cannot perform electrometer_status() command.");
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to electrometer status.",
                                      (const char*) "KeithleyElectrometer::dev_status()",
                                      Tango::ERR
                                     );
  }
  catch(Tango::DevFailed& df)
  {
    ERROR_STREAM << "Cannot perform electrometer_status() command" << std::endl;
    set_state(Tango::ALARM);
    set_status("Cannot perform electrometer_status() command.");

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to electrometer status.",
                                      (const char*) "KeithleyElectrometer::dev_status()",
                                      Tango::ERR
                                     );
  }
  catch(...)
  {
    FATAL_STREAM << "Cannot perform electrometer_status() command -> caught ... " << std::endl;
    throw;
  }

  return _statusStr.c_str();

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::dev_status
	set_status(status);               // Give the status to Tango.
	return Tango::DeviceImpl::dev_status();  // Return it.
}
//--------------------------------------------------------
/**
 *	Command RangeUP related method
 *	Description: Up the range of the electrometer.
 *               Throw :
 *               - electrometer::ElectrometerException if the range limit is reached
 *               - Tango::DevFailed if the command cannot be performed
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::range_up()
{
	// DEBUG_STREAM << "KeithleyElectrometers::RangeUP()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::range_up) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::range_up()"
    );
  }

  try
  {
    this->_electrometer->range_up();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to up the range.",
                                      (const char*) "KeithleyElectrometers::range_up()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::range_up
}
//--------------------------------------------------------
/**
 *	Command RangeDOWN related method
 *	Description: Down the range of the electrometer.
 *               Throw :
 *               - electrometer::ElectrometerException if the range is negative
 *               - Tango::DevFailed if the command cannot be performed
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::range_down()
{
	// DEBUG_STREAM << "KeithleyElectrometers::RangeDOWN()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::range_down) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::range_down()"
    );
  }

  try
  {
    this->_electrometer->range_down();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to down the range.",
                                      (const char*) "KeithleyElectrometers::range_down()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::range_down
}
//--------------------------------------------------------
/**
 *	Command AutoRangeON related method
 *	Description: Command to switch the electrometer auto range ON
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::auto_range_on()
{
	// DEBUG_STREAM << "KeithleyElectrometers::AutoRangeON()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::auto_range_on) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::auto_range_on()"
    );
  }

  try
  {
    this->_electrometer->autoRange_on();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the auto range ON.",
                                      (const char*) "KeithleyElectrometers::auto_range_on()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::auto_range_on
}
//--------------------------------------------------------
/**
 *	Command AutoRangeOFF related method
 *	Description: Command to switch the electrometer auto range OFF
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::auto_range_off()
{
	// DEBUG_STREAM << "KeithleyElectrometers::AutoRangeOFF()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::auto_range_off) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::auto_range_off()"
    );
  }

  try
  {
    this->_electrometer->autoRange_off();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the auto range OFF.",
                                      (const char*) "KeithleyElectrometers::auto_range_off()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::auto_range_off
}
//--------------------------------------------------------
/**
 *	Command ZeroCheckON related method
 *	Description: Command to switch the electrometer zero check ON
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::zero_check_on()
{
	// DEBUG_STREAM << "KeithleyElectrometers::ZeroCheckON()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::zero_check_on) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::zero_check_on()"
    );
  }

  try
  {
    this->_electrometer->zero_check_on();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the zero check ON.",
                                      (const char*) "KeithleyElectrometers::zero_check_on()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::zero_check_on
}
//--------------------------------------------------------
/**
 *	Command ZeroCheckOFF related method
 *	Description: Command to switch the electrometer zero check OFF
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::zero_check_off()
{
	// DEBUG_STREAM << "KeithleyElectrometers::ZeroCheckOFF()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::zero_check_off) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::zero_check_off()"
    );
  }

  try
  {
    this->_electrometer->zero_check_off();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the zero check OFF.",
                                      (const char*) "KeithleyElectrometers::zero_check_off()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::zero_check_off
}
//--------------------------------------------------------
/**
 *	Command ZeroCorrectON related method
 *	Description: Command to switch the electrometer zero correct ON
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::zero_correct_on()
{
	// DEBUG_STREAM << "KeithleyElectrometers::ZeroCorrectON()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::zero_correct_on) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::zero_correct_on()"
    );
  }

  try
  {
    this->_electrometer->zero_correct_on();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the zero correct ON.",
                                      (const char*) "KeithleyElectrometers::zero_correct_on()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::zero_correct_on
}
//--------------------------------------------------------
/**
 *	Command ZeroCorrectOFF related method
 *	Description: Command to switch the electrometer zero correct OFF
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::zero_correct_off()
{
	// DEBUG_STREAM << "KeithleyElectrometers::ZeroCorrectOFF()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::zero_correct_off) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::zero_correct_off()"
    );
  }

  try
  {
    this->_electrometer->zero_correct_off();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the zero correct OFF.",
                                      (const char*) "KeithleyElectrometers::zero_correct_off()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::zero_correct_off
}
//--------------------------------------------------------
/**
 *	Command AutoZeroON related method
 *	Description: To help maintain stability and accuracy over time and changes in temperature, the
 *               Model 6487 periodically measures internal voltages corresponding to offsets (zero) and
 *               amplifier gains. These measurements are used in the algorithm to calculate the reading of
 *               the input signal.
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::auto_zero_on()
{
	// DEBUG_STREAM << "KeithleyElectrometers::AutoZeroON()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::auto_zero_on) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::auto_zero_on()"
    );
  }

  try
  {
    this->_electrometer->auto_zero_on();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the auto zero ON.",
                                      (const char*) "KeithleyElectrometers::auto_zero_on()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::auto_zero_on
}
//--------------------------------------------------------
/**
 *	Command AutoZeroOFF related method
 *	Description: When autozero is disabled, the offset and gain measurements are not performed. This
 *               increases measurement speed up to three times. However, the zero and gain reference
 *               points can eventually drift resulting in inaccurate readings of the input signal. It is recommended
 *               that autozero only be disabled for short periods of time.
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::auto_zero_off()
{
	// DEBUG_STREAM << "KeithleyElectrometers::AutoZeroOFF()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::auto_zero_off) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::auto_zero_off()"
    );
  }

  try
  {
    this->_electrometer->auto_zero_off();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the auto zero OFF.",
                                      (const char*) "KeithleyElectrometers::auto_zero_off()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::auto_zero_off
}
//--------------------------------------------------------
/**
 *	Command SetAmperMeterMode related method
 *	Description: If supported, this command switch the electrometer in AmperMeter mode
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::set_amper_meter_mode()
{
	// DEBUG_STREAM << "KeithleyElectrometers::SetAmperMeterMode()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::set_amper_meter_mode) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::set_amper_meter_mode()"
    );
  }

  try
  {
    this->_electrometer->setAmperMeterMode();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the ammeter mode.",
                                      (const char*) "KeithleyElectrometers::set_amper_meter_mode()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::set_amper_meter_mode
}
//--------------------------------------------------------
/**
 *	Command SetVoltMeterMode related method
 *	Description: If supported, this command switch the electrometer in VoltMeter mode.
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::set_volt_meter_mode()
{
	// DEBUG_STREAM << "KeithleyElectrometers::SetVoltMeterMode()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::set_volt_meter_mode) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::set_volt_meter_mode()"
    );
  }

  try
  {
    this->_electrometer->setVoltMeterMode();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the volt meter mode.",
                                      (const char*) "KeithleyElectrometers::set_volt_meter_mode()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::set_volt_meter_mode
}
//--------------------------------------------------------
/**
 *	Command SetOhmMeterMode related method
 *	Description: If supported, this command switch the electrometer in OhmMeter mode.
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::set_ohm_meter_mode()
{
	// DEBUG_STREAM << "KeithleyElectrometers::SetOhmMeterMode()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::set_ohm_meter_mode) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::set_ohm_meter_mode()"
    );
  }

  try
  {
    this->_electrometer->setOhmMeterMode();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the ohm meter mode.",
                                      (const char*) "KeithleyElectrometers::set_ohm_meter_mode()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::set_ohm_meter_mode
}
//--------------------------------------------------------
/**
 *	Command SetCoulombMeterMode related method
 *	Description: If supported, this command switch the electrometer in Coulomb Meter mode.
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::set_coulomb_meter_mode()
{
	// DEBUG_STREAM << "KeithleyElectrometers::SetCoulombMeterMode()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::set_coulomb_meter_mode) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::set_coulomb_meter_mode()"
    );
  }

  try
  {
    this->_electrometer->setCoulombMeterMode();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the coulomb(charge) meter mode.",
                                      (const char*) "KeithleyElectrometers::set_coulomb_meter_mode()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::set_coulomb_meter_mode
}
//--------------------------------------------------------
/**
 *	Command ClearRegisters related method
 *	Description: Clear all registers.
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::clear_registers()
{
	// DEBUG_STREAM << "KeithleyElectrometers::ClearRegisters()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::clear_registers) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::clear_registers()"
    );
  }

  try
  {
    this->_electrometer->clear_registers();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to clear all status registers.",
                                      (const char*) "KeithleyElectrometers::clear_registers()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::clear_registers
}
//--------------------------------------------------------
/**
 *	Command AverageStateON related method
 *	Description: Enable digital filter
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::average_state_on()
{
	// DEBUG_STREAM << "KeithleyElectrometers::AverageStateON()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::average_state_on) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::average_state_on()"
    );
  }

  try
  {
    this->_electrometer->averageStateON();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to enable the calculation of the average.",
                                      (const char*) "KeithleyElectrometers::average_state_on()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::average_state_on
}
//--------------------------------------------------------
/**
 *	Command AverageStateOFF related method
 *	Description: Disable digital filter
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::average_state_off()
{
	// DEBUG_STREAM << "KeithleyElectrometers::AverageStateOFF()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::average_state_off) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::average_state_off()"
    );
  }

  try
  {
    this->_electrometer->averageStateOFF();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to disable the calculation of the average.",
                                      (const char*) "KeithleyElectrometers::average_state_off()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::average_state_off
}
//--------------------------------------------------------
/**
 *	Command ClearBuffer related method
 *	Description: This command clears all data previously stored.
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::clear_buffer()
{
	// DEBUG_STREAM << "KeithleyElectrometers::ClearBuffer()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::clear_buffer) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::clear_buffer()"
    );
  }

  try
  {
    this->_electrometer->clear_buffer();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to clear device internal buffer.",
                                      (const char*) "KeithleyElectrometers::clear_buffer()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::clear_buffer
}
//--------------------------------------------------------
/**
 *	Command Start related method
 *	Description: Trigger one or more reading(s)
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::start()
{
	// DEBUG_STREAM << "KeithleyElectrometers::Start()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::start) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::start()"
    );
  }

  try
  {
    //- TODO : check if attributes have been set
    this->_electrometer->init_keithley();
    _integrationStarted = true;
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to trigger readings.",
                                      (const char*) "KeithleyElectrometers::start()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::start
}
//--------------------------------------------------------
/**
 *	Command Reset related method
 *	Description: Reset to factory settings
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::reset()
{
	// DEBUG_STREAM << "KeithleyElectrometers::Reset()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::reset) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::reset()"
    );
  }

  try
  {
    this->_electrometer->reset();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to set the electrometer to its default state.",
                                      (const char*) "KeithleyElectrometers::reset()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::reset
}
//--------------------------------------------------------
/**
 *	Command Abort related method
 *	Description: SCPI command only
 *               Cancels all operations started by Start command
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::abort()
{
	// DEBUG_STREAM << "KeithleyElectrometers::Abort()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::abort) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::abort()"
    );
  }

  try
  {
    this->_electrometer->abort();
    _integrationStarted = false;
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to cancel operation(s).",
                                      (const char*) "KeithleyElectrometer::abort()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::abort
}
//--------------------------------------------------------
/**
 *	Command EnableSRQBufferFull related method
 *	Description: Sets Buffer Full bit in the MEASUREMENT REGISTER EVENT.
 *               To know if the integration is finished, check :
 *               - if the attribute isDataAvailable is true
 *               or
 *               - if the device state is STANDBY
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::enable_srqbuffer_full()
{
	// DEBUG_STREAM << "KeithleyElectrometers::EnableSRQBufferFull()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::enable_srqbuffer_full) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::enable_srqbuffer_full()"
    );
  }

  try
  {
    this->_electrometer->enable_SRQBufferFull();
    _is_srqbuffer_full_enabled = true;
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to enable device measurement register event.",
                                      (const char*) "KeithleyElectrometers::enable_srqbuffer_full()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::enable_srqbuffer_full
}
//--------------------------------------------------------
/**
 *	Command DisableSRQBufferFull related method
 *	Description: Resets all events in the device registers.
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::disable_srqbuffer_full()
{
	// DEBUG_STREAM << "KeithleyElectrometers::DisableSRQBufferFull()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::disable_srqbuffer_full) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::disable_srqbuffer_full()"
    );
  }

  try
  {
    this->_electrometer->disable_SRQBufferFull();
    _is_srqbuffer_full_enabled = false;
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to reset device measurement register event .",
                                      (const char*) "KeithleyElectrometers::disable_srqbuffer_full()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::disable_srqbuffer_full
}
//--------------------------------------------------------
/**
 *	Command GetKeithleyConfig related method
 *	Description: Returns the Keithley DDC model configuration such as TriggerMode, mode, ....
 *
 *	@returns DDC Keithley configuration
 */
//--------------------------------------------------------
Tango::DevString KeithleyElectrometers::get_keithley_config()
{
	Tango::DevString argout;
	// DEBUG_STREAM << "KeithleyElectrometers::GetKeithleyConfig()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::get_keithley_config) ENABLED START -----*/
	
	//	Add your own code
	//  POGO has generated a method core with argout allocation.
  //  If you would like to use a static reference without copying,
  //  See "TANGO Device Server Programmer's Manual"
  //    (chapter : Writing a TANGO DS / Exchanging data)
  //------------------------------------------------------------

  //  Add your own code to control device here
  if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::get_keithley_config()"
    );
  }

  try
  {
    std::string kConfig("");
    //- Only for DDC Keithley devices
    if( !this->_kSCPItype )
    {
      kConfig = this->_electrometer->get_configuration();
      if ( !kConfig.empty() )
      {
        argout = new char[kConfig.size()+1];
        if (argout)
          ::strcpy(argout, kConfig.c_str());
        else
          throw std::bad_alloc();
      }
      else
      {
        std::string default_status("No status data received from the Keithley device.");
        argout = new char[default_status.size()+1];
        if (argout)
          ::strcpy(argout, default_status.c_str());
        else
          throw std::bad_alloc();
      }
    }
    else //- SCPI types
    {
      std::string cmd_not_allowed("Command only available for DDC Keithley devices");
      argout = new char[cmd_not_allowed.size()+1];
      if (argout)
        ::strcpy(argout, cmd_not_allowed.c_str());
      else
        throw std::bad_alloc();
    }
    DEBUG_STREAM << "KeithleyElectrometers::get_keithley_config(): " << argout << endl;
  }
  catch(...)
  {
    if (argout)
    {
      delete [] argout;
      argout = 0;
    }
    throw;
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::get_keithley_config
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetRange related method
 *	Description: Returns the electrometer range value.
 *
 *	@returns The electrometer range value
 */
//--------------------------------------------------------
Tango::DevString KeithleyElectrometers::get_range()
{
	Tango::DevString argout;
	// DEBUG_STREAM << "KeithleyElectrometers::GetRange()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::get_range) ENABLED START -----*/
	
	//	Add your own code
	//  POGO has generated a method core with argout allocation.
  //  If you would like to use a static reference without copying,
  //  See "TANGO Device Server Programmer's Manual"
  //    (chapter : Writing a TANGO DS / Exchanging data)
  //------------------------------------------------------------
  std::string kRange("");
//   DEBUG_STREAM << "KeithleyElectrometers::get_range(): entering... !" << endl;

  //  Add your own code to control device here
  if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::get_range()"
    );
  }

  try
  {
    kRange = this->_electrometer->get_ElectroMeterRange();
    argout = new char[kRange.size()+1];
    argout = CORBA::string_dup( kRange.c_str() );
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    if(argout)
    {
      delete[] argout;
      argout = 0;
    }
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    FATAL_STREAM << "Failed to read the range :\n" << df << std::endl;
    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to read the range.",
                                      (const char*) "KeithleyElectrometers::get_range()",
                                      Tango::ERR
                                     );
  }
  catch(...)
  {
    if(argout)
    {
      delete[] argout;
      argout = 0;
    }
    throw;
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::get_range
	return argout;
}
//--------------------------------------------------------
/**
 *	Command SetRange related method
 *	Description: Sets the new electrometer range value.
 *
 *	@param argin Index of the new range value to set (cf rangesList atrribute to get ranges indexes).
 */
//--------------------------------------------------------
void KeithleyElectrometers::set_range(Tango::DevUShort argin)
{
	// DEBUG_STREAM << "KeithleyElectrometers::SetRange()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::set_range) ENABLED START -----*/
	
    _electrometer->set_ElectroMeterRange(argin);
	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::set_range
}
//--------------------------------------------------------
/**
 *	Command GetMode related method
 *	Description: Returns the electrometer mode.
 *
 *	@returns The electrometer mode
 */
//--------------------------------------------------------
Tango::DevString KeithleyElectrometers::get_mode()
{
	Tango::DevString argout;
	// DEBUG_STREAM << "KeithleyElectrometers::GetMode()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::get_mode) ENABLED START -----*/
	
	//	Add your own code
	//  POGO has generated a method core with argout allocation.
  //  If you would like to use a static reference without copying,
  //  See "TANGO Device Server Programmer's Manual"
  //    (chapter : Writing a TANGO DS / Exchanging data)
  //------------------------------------------------------------
  std::string kMode("");
//   DEBUG_STREAM << "KeithleyElectrometers::get_mode(): entering... !" << endl;

  //  Add your own code to control device here
  if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      (const char*) "INIT_ERROR",
      (const char*) "Device is not well initialized.",
      (const char*) "KeithleyElectrometer::get_mode()"
    );
  }

  try
  {
    kMode = this->_electrometer->get_ElectroMeterMode();
    argout = new char[kMode.size()+1];
    argout = CORBA::string_dup( kMode.c_str() );
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    if(argout)
    {
      delete[] argout;
      argout = 0;
    }
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    FATAL_STREAM << "Failed to read the mode :\n" << df << std::endl;
    Tango::Except::re_throw_exception(df,
                                      (const char*) "UNKNOWN_ERROR",
                                      (const char*) "Failed to read the mode",
                                      (const char*) "KeithleyElectrometers::get_mode()",
                                      Tango::ERR
                                     );
  }
  catch(...)
  {
    if(argout)
    {
      delete[] argout;
      argout = 0;
    }
    throw;
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::get_mode
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetIntegrationTime related method
 *	Description: Returns the electrometer integration time (in seconds).
 *
 *	@returns the integration time value
 */
//--------------------------------------------------------
Tango::DevDouble KeithleyElectrometers::get_integration_time()
{
	Tango::DevDouble argout;
	// DEBUG_STREAM << "KeithleyElectrometers::GetIntegrationTime()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::get_integration_time) ENABLED START -----*/
	
	//	Add your own code
//   DEBUG_STREAM << "KeithleyElectrometers::get_integration_time(): entering... !" << endl;

  //  Add your own code to control device here
  if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not well initialized.",
      "KeithleyElectrometer::get_integration_time()"
    );
  }

  if ( this->_kSCPItype )
  {
    double knplc = yat::XString<double>::to_num(this->_electrometer->get_knplc());
    double nbtrig = yat::XString<double>::to_num(this->_electrometer->get_triggercount());

    argout = knplc * nbtrig;
  }
  else if (electrometerType==486 || electrometerType==487)
  {
    short buffSize = this->_electrometer->get_buffer_size();
    //- 175ms = conversion rate
    argout = 0.175 * buffSize;
  }
  else if (electrometerType==6512 || electrometerType==617)
  {
    //- 360ms = conversion rate && 100 = buffersize limit (cannot be set)
    argout = 0.360 * 100;

  }//- to old DDC Keithleys
  else
  {
    FATAL_STREAM << "This Keithley model cannot return the integration time value." << std::endl;
    Tango::Except::throw_exception(
      "COMMAND_NOT_SUPPORTED",
      "This Keithley model cannot return the integration time value.",
      "KeithleyElectrometer::get_integration_time()");
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::get_integration_time
	return argout;
}
//--------------------------------------------------------
/**
 *	Command SetIntegrationTime related method
 *	Description: Sets the new electrometer integration time value (in seconds).
 *
 *	@param argin The integration time value (in seconds)
 */
//--------------------------------------------------------
void KeithleyElectrometers::set_integration_time(Tango::DevDouble argin)
{
	// DEBUG_STREAM << "KeithleyElectrometers::SetIntegrationTime()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::set_integration_time) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not well initialized.",
      "KeithleyElectrometer::set_integration_time()"
    );
  }

  try
  {
    this->_electrometer->set_integrationTime(argin);
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    FATAL_STREAM << "Failed to write integration time value :\n" << df << std::endl;

    Tango::Except::re_throw_exception(df,
                                      "UNKNOWN_ERROR",
                                      "Failed to write integration time value",
                                      "KeithleyElectrometer::set_integration_time()",
                                      Tango::ERR
                                     );
  }
  catch(Tango::DevFailed& df)
  {
    FATAL_STREAM << "Failed to write integration time value :\n" << df << std::endl;

    Tango::Except::re_throw_exception(df,
                                      "UNKNOWN_ERROR",
                                      "Failed to electrometer status.",
                                      "KeithleyElectrometer::set_integration_time()",
                                      Tango::ERR
                                     );
  }
  catch(...)
  {
    std::string error("Failed to write integration time value : caught [...]");
    FATAL_STREAM << error << std::endl;

    Tango::Except::throw_exception(
      "UNKNOWN_ERROR",
      error.c_str(),
      "KeithleyElectrometer::set_integration_time()",
      Tango::ERR
    );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::set_integration_time
}
//--------------------------------------------------------
/**
 *	Command VSourceOutputON related method
 *	Description: Enables the V-SOURCE output
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::vsource_output_on()
{
	// DEBUG_STREAM << "KeithleyElectrometers::VSourceOutputON()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::vsource_output_on) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not well initialized.",
      "KeithleyElectrometer::vsource_output_on()"
    );
  }

  try
  {
    this->_electrometer->enable_VSourceOutput();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      "UNKNOWN_ERROR",
                                      "Failed to enable the VSource output.",
                                      "KeithleyElectrometers::vsource_output_on()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::vsource_output_on
}
//--------------------------------------------------------
/**
 *	Command VSourceOutputOFF related method
 *	Description: Disables the V-SOURCE output
 *
 */
//--------------------------------------------------------
void KeithleyElectrometers::vsource_output_off()
{
	// DEBUG_STREAM << "KeithleyElectrometers::VSourceOutputOFF()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::vsource_output_off) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not well initialized.",
      "KeithleyElectrometer::vsource_output_off()"
    );
  }

  try
  {
    this->_electrometer->disable_VSourceOutput();
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      "UNKNOWN_ERROR",
                                      "Failed to disable the VSource output.",
                                      "KeithleyElectrometers::vsource_output_off()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::vsource_output_off
}
//--------------------------------------------------------
/**
 *	Command SaveConfiguration related method
 *	Description: Save the Keithley configuration.
 *
 *	@param argin Configuration index number
 */
//--------------------------------------------------------
void KeithleyElectrometers::save_configuration(Tango::DevUShort argin)
{
	// DEBUG_STREAM << "KeithleyElectrometers::SaveConfiguration()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::save_configuration) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not well initialized.",
      "KeithleyElectrometer::save_configuration()"
    );
  }

  try
  {
    this->_electrometer->save_configuration(argin);
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      "UNKNOWN_ERROR",
                                      "Failed to save current Keithley configuration.",
                                      "KeithleyElectrometers::save_configuration()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::save_configuration
}
//--------------------------------------------------------
/**
 *	Command RestoreConfiguration related method
 *	Description: Restores the saved Keithley configuration, stored at the specified index.
 *
 *	@param argin Configuration index to restore
 */
//--------------------------------------------------------
void KeithleyElectrometers::restore_configuration(Tango::DevUShort argin)
{
	// DEBUG_STREAM << "KeithleyElectrometers::RestoreConfiguration()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyElectrometers::restore_configuration) ENABLED START -----*/
	
	//	Add your own code
	if ( !this->_electrometer )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not well initialized.",
      "KeithleyElectrometer::restore_configuration()"
    );
  }

  try
  {
    this->_electrometer->restore_configuration(argin);
  }
  catch(const electrometer::ElectrometerException& ke)
  {
    Tango::DevFailed df = electrometer_to_tango_exception(ke);

    Tango::Except::re_throw_exception(df,
                                      "UNKNOWN_ERROR",
                                      "Failed to restore this Keithley configuration.",
                                      "KeithleyElectrometers::restore_configuration()",
                                      Tango::ERR
                                     );
  }

	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::restore_configuration
}
//--------------------------------------------------------
/**
 *	Method      : KeithleyElectrometers::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void KeithleyElectrometers::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(KeithleyElectrometers::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::add_dynamic_commands
}

/*----- PROTECTED REGION ID(KeithleyElectrometers::namespace_ending) ENABLED START -----*/

//	Additional Methods
//+----------------------------------------------------------------------------
//
// method : KeithleyElectrometer::electrometer_to_tango_exception()
//
// description :   Extract real attribute values from
//        hardware acquisition result.
//
//-----------------------------------------------------------------------------
Tango::DevFailed KeithleyElectrometers::electrometer_to_tango_exception(const electrometer::ElectrometerException& de)
{
  Tango::DevErrorList error_list(de.errors.size());
  error_list.length(de.errors.size());

  for(unsigned int i = 0; i < de.errors.size(); i++)
  {
    error_list[i].reason = CORBA::string_dup(de.errors[i].reason.c_str());
    error_list[i].desc   = CORBA::string_dup(de.errors[i].desc.c_str());
    error_list[i].origin = CORBA::string_dup(de.errors[i].origin.c_str());

    switch(de.errors[i].severity)
    {
    case electrometer::WARN:
      error_list[i].severity = Tango::WARN;
      break;
    case electrometer::PANIC:
      error_list[i].severity = Tango::PANIC;
      break;
    case electrometer::ERR:
    default:
      error_list[i].severity = Tango::ERR;
      break;
    }
  }
  return Tango::DevFailed(error_list);
}
void KeithleyElectrometers::create_keithleyModel_object()
{
  bool success = false;

  try
  {
    INFO_STREAM << "\n\n : create_keithleyModel_object() ENTERING for  -> " << electrometerType << std::endl;
    switch(electrometerType)
    {
    case 485 :
      this->_electrometer = new Keithley_485 (communicationLinkName);
      this->_kSCPItype = false;
      break;
    case 486 :
      this->_electrometer = new Keithley_486 (communicationLinkName);
      this->_kSCPItype = false;
      break;
    case 487 :
      this->_electrometer = new Keithley_487 (communicationLinkName);
      this->_kSCPItype = false;
      break;
    case 617 :
      this->_electrometer = new Keithley_617 (communicationLinkName);
      this->_kSCPItype = false;
      break;
    case 6485:
      this->_electrometer = new Keithley_6485 (communicationLinkName);
      this->_kSCPItype = true;
      break;
    case 6487:
      this->_electrometer = new Keithley_6487 (communicationLinkName);
      this->_kSCPItype = true;
      break;
    case 6512:
      this->_electrometer = new Keithley_6512 (communicationLinkName);
      this->_kSCPItype = false;
      break;
    case 6514:
      this->_electrometer = new Keithley_6514 (communicationLinkName);
      this->_kSCPItype = true;
      break;
    case 6517:
      this->_electrometer = new Keithley_6517 (communicationLinkName);
      this->_kSCPItype = true;
      break;
    default :
      this->_electrometer = 0;
      FATAL_STREAM << "\nERROR : Electrometers::init_device() -> this " << electrometerType << " Keithley type is not supported now !" << endl;
      break;
    }

    //- Default Keithley configuration :
    if ( this->_electrometer )
    {
      success = this->_electrometer->init_protocol();

      if(success)
      {
        //- only Keithley 485 doesn't support this cmd :
        if (electrometerType != 485)
        {
          //- Send AutoRange OFF
          this->auto_range_off();
        }
        //- Send ZeroCheck OFF
        this->zero_check_off();
//        this->_init_failed = false;
      }
//      else
//        this->_init_failed = true;
      INFO_STREAM << "\n : create_keithleyModel_object() for  -> " << electrometerType << std::endl;
    }
    else
    {
//      this->_init_failed = true;
      FATAL_STREAM << "\n : create_keithleyModel_object() for  -> " << electrometerType << std::endl;
    }
  }
  catch(Tango::DevFailed& df)
  {
    FATAL_STREAM << "create_keithleyModel_object() for  -> " << electrometerType << " caught DevFailed -> \n" << df << std::endl;

    Tango::Except::re_throw_exception(df,
                                      "UNKNOWN_ERROR",
                                      "Failed to electrometer status.",
                                      "KeithleyElectrometer::set_integration_time()",
                                      Tango::ERR
                                     );
  }
  catch(...)
  {
    FATAL_STREAM << "create_keithleyModel_object() for  -> " << electrometerType << " caught [...]" << std::endl;
    //- For SCPI Keithleys models a command is sent at init :
    //-  this, to query the value only with no timestamp !!!
    //-  If the device is not ON or if there is a Gpib communication
    //-  problem, an exception is raised.
//    this->_init_failed = true;
    throw;
  }
}
//==================================================================
//                      INTERNAL METHODS
//==================================================================

void KeithleyElectrometers::add_dynamic_attribute(Tango::Attr* attr)
{
  try
  {
    //- add the attribute to the device
    add_attribute(attr);
    //- keep trace of dynamically created attributes
    _added_attributes.push_back(attr);
  }
  catch(...)
  {
    FATAL_STREAM << "FATAL -> Could not add attribute " << attr->get_name() << " !" << std::endl;
  }
}
// ============================================================================
//- KeithleyElectrometers::create_dynamic_attributes
// ============================================================================
void KeithleyElectrometers::create_dynamic_attributes (void)
{
//   DEBUG_STREAM << "KeithleyElectrometers::create_dynamic_attributes () <-" << std::endl;

  if ( useMultiplexedChannels )
  {
    //- create attribute channel :
    std::string channelNumStr = "channelNumber";
    channelNumberAttr* attr_ch_name = new channelNumberAttr(channelNumStr, communicationLinkName);
    add_dynamic_attribute(attr_ch_name);
    _added_attribute_name.push_back(channelNumStr);
    INFO_STREAM << "KeithleyElectrometers::create_dynamic_attributes () -> channelNumber DONE." << std::endl;
  }

  if ( createDynamicVSourceAttribute )
  {
    //- create attribute vSource :
    std::string vSrcStr = "vSource";
    vSourceAttr* attr_vSrc_name = new vSourceAttr(vSrcStr, communicationLinkName);
    add_dynamic_attribute(attr_vSrc_name);
    _added_attribute_name.push_back(vSrcStr);
    INFO_STREAM << "KeithleyElectrometers::create_dynamic_attributes () -> vSource DONE." << std::endl;
  }
}
// ============================================================================
//- KeithleyElectrometers::remove_dynamic_attibutes
// ============================================================================
void KeithleyElectrometers::remove_dynamic_attibutes()
{
  for(unsigned long i=0; i<_added_attributes.size(); i++)
  {
    std::string name = _added_attributes[i]->get_name();
    //- remove the attribute from the device and delete it
    try
    {
      remove_attribute(_added_attributes[i],true);
      INFO_STREAM << "Removed attribute " << name << std::endl;
    }
    catch(...)
    {
      FATAL_STREAM << "Could not remove attribute " << name << " !" << std::endl;
    }
  }

  //- clear the added attributes list
  _added_attributes.clear();
}


/*----- PROTECTED REGION END -----*/	//	KeithleyElectrometers::namespace_ending
} //	namespace
